#4524 closed defect (fixed)

Re-add lost capability for custom stack allocator to allocate IDLE thread stacks

Reported by: Joel Sherrill Owned by: Joel Sherrill <joel@…>
Priority: normal Milestone: 6.1
Component: rtems Version: 6
Severity: normal Keywords: qualification
Cc: Blocked By:
Blocking:

Description

The move to statically allocate the stacks for the IDLE threads resulted in the loss of the capability for a custom stack allocator to be able to allocate the idle threads' stacks. This occurred close to the 5 branching point and is addressed for the 5 branch by #4520. This ticket is for the master (6).

Change History (11)

comment:1 Changed on 10/11/21 at 13:39:59 by Joel Sherrill <joel@…>

Owner: set to Joel Sherrill <joel@…>
Resolution: fixed
Status: newclosed

In 822ebb4c/rtems:

Add support for IDLE Thread stack allocator

Add a stack allocator hook specifically for allocation of IDLE thread stacks.
This allows the user to decide if IDLE thread stacks are statically allocated
or handled by the same custom allocator mechanism as other thread stacks.

Closes #4524.

comment:2 Changed on 10/12/21 at 18:44:34 by Joel Sherrill <joel@…>

In df5be4c/rtems-docs:

task-stack-alloc.rst: Add CONFIGURE_TASK_STACK_FROM_ALLOCATOR

Updates #4524.

comment:3 Changed on 10/25/21 at 06:00:27 by Sebastian Huber <sebastian.huber@…>

In 9be97a3/rtems:

score: Optimize default idle task stack allocator

Update #4524.

comment:4 Changed on 10/25/21 at 06:00:37 by Sebastian Huber <sebastian.huber@…>

In f1723d12/rtems:

rtems: Regenerate for IDLE task allocator option

Update #4524.

comment:5 Changed on 10/25/21 at 06:10:52 by Sebastian Huber <sebastian.huber@…>

In 46dbb6d/rtems-docs:

c-user: Regenerate for IDLE task allocator option

Update #4524.

comment:6 Changed on 02/23/22 at 08:29:13 by Sebastian Huber <sebastian.huber@…>

In 2f8be4b/rtems-docs:

c-user: Document CONFIGURE_SCHEDULER_TABLE_ENTRIES

Update #4524.

comment:7 Changed on 02/23/22 at 14:30:15 by Sebastian Huber

The last commit does not belong to this ticket. It references the wrong ticket number.

comment:8 Changed on 10/14/22 at 09:41:45 by Sebastian Huber <sebastian.huber@…>

In 2846b17/rtems:

config: Changeable size for IDLE stack allocator

Allow the IDLE stack allocator to change the stack size. This can be
used by applications with a very dynamic thread-local storage size to
adjust the thread storage area of the IDLE tasks dynamically.

Update #4524.

comment:9 Changed on 10/14/22 at 09:42:01 by Sebastian Huber <sebastian.huber@…>

In 45ee958/rtems:

config: Add CONFIGURE_IDLE_TASK_STORAGE_SIZE

By default, allocate the IDLE task storage areas from the RTEMS Workspace.
This avoids having to estimate the thread-local storage size in the default
configuration.

Add the application configuration option CONFIGURE_IDLE_TASK_STORAGE_SIZE to
request a static allocation of the task storage area for IDLE tasks.

Update #3835.
Update #4524.

comment:10 Changed on 10/14/22 at 09:42:03 by Sebastian Huber <sebastian.huber@…>

In 64fbeaa/rtems:

score: INTERNAL_ERROR_IDLE_THREAD_STACK_TOO_SMALL

Ensure that the IDLE storage allocator did allocate a suffiently large area.

Update #3835.
Update #4524.

comment:11 Changed on 05/02/23 at 08:12:16 by Sebastian Huber

Keywords: qualification added
Note: See TracTickets for help on using tickets.